var ARRAY_ELEMENT_SPLITTER = '_:_';
var ARRAY_SPLITTER = '_::_';
var BARS_DISABLED_DELAY = 50;
var BARS_ENABLED_DELAY = 100;
var CANVAS = {};
var CANVAS_BLOCKER_CLASS = 'canvas-blocker';
var CLIPBOARD_ACTIVE = true;
var CLIPBOARD_COPY = 'copy';
var CLIPBOARD_CUT = 'cut';
var CLIPBOARD_DATA = '';
var CLIPBOARD_DATA_WAITING = false;
var CLIPBOARD_ID = '__dv_clipboard_dv__';
var CLIPBOARD_PASTE = 'paste';
var CLIPBOARD_ENABLED = {};
var CLIPBOARD_TARGETS = ['UTF8_STRING', 'TEXT', 'STRING', 'text/plain'];
var DIALOG_CLASS = 'ui-dialog-';
var DIALOG_TITLE_ICON = 'ui-dialog-title-icon';
var DIALOG_OVERLAY = 'ui-widget-overlay';
var DRAWING_DATA_CANVAS = 'canvas';
var DRAWING_DATA_CANVAS_ELEMENT = '<canvas/>';
var DRAWING_DATA_CANVAS_ID = '-' + DRAWING_DATA_CANVAS;
var DRAWING_DATA_FRAME_TIME_FACTOR = 10000;
var DRAWING_DATA_QUEUE = [];
var DRAWING_DATA_QUEUE_STEP = 2;
var DRAWING_DATA_RUNNING = false;
var DRAWING_DATA_SEQUENCE = [];
var DRAWING_DATA_SEQUENCE_STEP = 5;
var DRAWING_DATA_TIMER = null;
var DRAWING_DATA_TIMER_ID = 'dvirtual';
var DRAWING_DATA_TIMER_INTERVAL = 0;
var DRAWING_DATA_TIMER_RUNNING = false;
var DRAWING_DATA_TYPE_H264 = 'h264';
var DRAWING_DATA_TYPE_JPEG = 'jpeg';
var DRAWING_DATA_TYPE_PNG = 'png';
var DRAWING_DATA_TYPE_RGB = 'rgb';
var DRAWING_DATA_TYPE_RGB_ZLIB = 'zlib_rgb';
var DRAWING_DATA_TYPE_RGB32 = 'rgb32';
var DRAWING_DATA_TYPE_RGB32_LZ4 = 'lz4_rgb32';
var DRAWING_DATA_TYPE_RGB32_ZLIB = 'zlib_rgb32';
var DRAWING_DATA_TYPE_SCROLL = 'scroll';
var DRAWING_DATA_TYPE_WEBP = 'webp';
var DRAWING_DATA_UNDEFINED = 'undefined';
var FULL_SCREEN = false;
var FULL_SCREEN_BOTTOM_APPLICATIONS_CLASS = 'fullscreen-bottom-applications';
var FULL_SCREEN_BOTTOM_CLASS = 'fullscreen-bottom';
var FULL_SCREEN_BUTTON_CLASS = 'fullscreen';
var FULL_SCREEN_ELEMENT_CLASS = 'canvas-ui';
var FULL_SCREEN_TOP_APPLICATIONS_CLASS = 'fullscreen-top-applications';
var FULL_SCREEN_TOP_CLASS = 'fullscreen-top';
var KEYBOARD_CAPS_LOCK = null;
var KEYBOARD_NUM_LOCK = null;
var LZ4 = require(['lz4']);
var LZ4_BUFFER = require('buffer').Buffer;
var MENU_BAR_ITEMS_SHOW_DELAY = 10;
var MODIFIER_CAPS_LOCK = 'CapsLock';
var MODIFIER_NUM_LOCK = 'NumLock';
var NOTIFICATIONS_HIDE_DELAY = 10;
var NOTIFICATIONS_SHOW_DELAY = 10;
var OFFSCREEN_CANVAS = null;
var OFFSCREEN_CANVAS_CONTEXT = null;
var REQUEST_ANOTHER_INTERVAL = 10;
var REQUEST_FIRST_INTERVAL = 0;
var OS_MAC = navigator.platform.includes('Mac');
var OS_WINDOWS = navigator.platform.includes('Win');
var SIDEBAR = 'sidebar';
var TOOLTIP_SHOW_DELAY = 1080;
var TRANSLATION_APPLICATIONS = 'Applications';
var TRANSLATION_RUNNING_APPLICATIONS = 'Running applications';
var WINDOW_FOCUSED = '';
var WINDOW_LOGO_IMAGE = null;
var WINDOW_POSITION_DELAY = 500;
var WINDOW_SCREENSHOT_CREATOR = 'Powered by dVirtual © ' + (new Date().getFullYear()) + ' Dušan Vejnović';
var WINDOW_SCREENSHOT_IMAGE = null;
var WINDOW_SCREENSHOT_TITLE = 'dVirtual Screenshoot';
var WINDOW_TITLE_BAR_BUTTON_IMAGE = {};
var WINDOW_TITLE_BAR_ICON_IMAGE = {};
var WINDOW_TITLE_CLICK_DELAY = 100;
var WINDOWS_VISIBLE = false
var WINDOWS_VISIBLE_DELAY = 0;
var WINDOWS_VISIBLE_NORMAL_DELAY = 0;
var WINDOWS_VISIBLE_SLOW_DELAY = 300;
var ZERO_WINDOW_ID = 0;
const WINDOW_ACTION = {
		CLOSE_WINDOW: 'CLOSE_WINDOW',
		MAXIMIZE_WINDOW: 'MAXIMIZE_WINDOW',
		RESTORE_WINDOW: 'RESTORE_WINDOW'
	};
const WINDOW_TYPE = {
		COMBO: 'COMBO',
		DEFAULT: '',
		DND: 'DND',
		DIALOG: 'DIALOG',
		DROPDOWN: 'DROPDOWN',
		DROPDOWN_MENU: 'DROPDOWN_MENU',
		MENU: 'MENU',
		NORMAL: 'NORMAL',
		POPUP_MENU: 'POPUP_MENU',
		SPLASH: 'SPLASH',
		TOOLBAR: 'TOOLBAR',
		TOOLTIP: 'TOOLTIP',
		UNKNOWN: 'UNKNOWN',
		UTILITY: 'UTILITY'
};

function allWindowsVisible(masterDiv, windowsVisible) {
	$(document).ready(function() {
		WINDOWS_VISIBLE = windowsVisible;
		WINDOWS_VISIBLE_DELAY = windowsVisible ? WINDOWS_VISIBLE_DELAY : WINDOWS_VISIBLE_SLOW_DELAY;
		if(windowsVisible && masterDiv !== null) {
			$(document).ready(function() {
				var $masterDiv = $($.id(masterDiv.id));
				var $server = getServer($masterDiv);
				if ($server !== undefined) {
					var functionExecuted = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								WINDOWS_VISIBLE_DELAY = WINDOWS_VISIBLE_NORMAL_DELAY;
								$masterDiv.children().css('visibility', 'visible');
								$server.setAllWindowsVisible();
								functionExecuted = true;
							} catch (error) {
								functionExecuted = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, WINDOWS_VISIBLE_DELAY );
				}
			});
		}
	});
}

function arrangeWindows(masterDiv, ids) {
	if (masterDiv !== null && ids !== null && ids.length > 1) {
		var idsArray = [];
		var $mainDiv = $($.id(masterDiv.id));
		$mainDiv.children($.clazz('ui-dialog-NORMAL')).each(function() {
			var canvasDivId = $(this).children('[id^="' + masterDiv.id + '-"]').attr('id').split('-').pop();
			if (ids.split(';').indexOf(canvasDivId) >= 0) {
				idsArray.push(canvasDivId);
			}			
		});
		idsArray = $.grep(idsArray, function(id) { return (id); });
		idsArray.sort(function(id1, id2) { return (id1 - id2); });
		
		// arrange windows
		var rows = Math.trunc(Math.sqrt(idsArray.length)) || 0;
		var columns = Math.trunc(idsArray.length / rows) || 0;
		columns = ((columns + 1) * rows - idsArray.length) < (idsArray.length - columns * rows) ? (columns + 1) : columns;
		if (rows >= 1 && columns > 1) {
			var rowHeight = $mainDiv.innerHeight() / rows;
			var columnsWidth = $mainDiv.innerWidth();
			var cloumnsInLastRow = idsArray.length - (rows - 1) * columns || 1;
			$.each(idsArray, function(index, id) {
				var dxy = calculateDxy(masterDiv.id + '-' + id);
				var row = Math.min(Math.trunc(index / columns), rows - 1);
				var column = index - columns * row;
				var height = rowHeight - 2 * dxy[1] - dxy[2];
				var width = ((row + 1) < rows ? columnsWidth/columns : columnsWidth/cloumnsInLastRow) - 2 * dxy[0];  
				var left = width * column + column * 2 * dxy[0];
				var top = rowHeight * row;
				var $server = getServer($mainDiv);
				if ($server !== undefined) {
					var functionExecuted = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server.setWindowDimensions(id, left, top, width, height);
								moveResizeWindow($mainDiv[0], id, left, top, width, height, false);
								functionExecuted = true;
							} catch (error) {
								functionExecuted = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);
				}
			});
		}
	}
}

function clientProperties(element) {
	$(document).ready(function() {
		// dpi
		var dpi = 0;
		var $dpi = $('<div />').attr('id', 'dpi').css({
			width: '1in',
			height: '1in', 
			left: '-100%',
			top: '-100%',
			position: 'absolute'
		}).appendTo('body');
		if ($dpi.outerWidth() > 0 && $dpi.outerHeight() > 0) {
			dpi = Math.round(($dpi.outerWidth() + $dpi.outerHeight())/2);
		} else if ('deviceXDPI' in screen) {
			dpi = Math.round((screen.systemXDPI + screen.systemYDPI)/2);
		}
		$dpi.dialog({hide: false});
		var dxy = calculateDxy('dpi');
		$dpi.remove();

		// webp enabled
		var webpEnabled = false;
		var webpElement = document.createElement('canvas');
		if (!!(webpElement.getContext && webpElement.getContext('2d')))
		{
			webpEnabled = webpElement.toDataURL('image/webp').indexOf('data:image/webp') === 0;
		}

		// color gamut
		var colorGamut = '';
		if (!window.matchMedia) {
			// nothing to do
		} else if (window.matchMedia('(color-gamut: rec2020)').matches) {
			colorGamut = 'rec2020';
		} else if (window.matchMedia('(color-gamut: p3)').matches) {
			colorGamut = 'P3';
		} else if (window.matchMedia('(color-gamut: srgb)').matches) {
			colorGamut = 'srgb';
		}

		// window's dimensions
		var $element = $(element);
		var height = $element.innerHeight() - 2 * dxy[1] - dxy[2];
		var width = $element.innerWidth() - 2 * dxy[0];
		var $server1 = getServer($element);
		if ($server1 !== undefined) {
			var functionExecuted1 = false;
			setTimeout(function run() {
				if (!isAnotherRequestActive()) {
					try {
						$server1.setClientProperties(width, height, dpi, colorGamut, webpEnabled, OS_WINDOWS, OS_MAC);
						functionExecuted1 = true;
					} catch (error) {
						functionExecuted1 = false;
					}
				}
				// function is not executed, let's try again
				if (functionExecuted1 === false) {
					setTimeout(run, REQUEST_ANOTHER_INTERVAL);
				}
			}, REQUEST_FIRST_INTERVAL);
		}

		// window resize event
		$(window).on('resizeEnd', function(event) {
			if (!$(event.target).hasClass('ui-resizable')) {
				var $element = $(element);
				var $server2 = getServer($element.parent());
				if ($server2 !== undefined) {
					var functionExecuted2 = false;
					var height = $element.innerHeight() - 2 * dxy[1] - dxy[2];
					var width = $element.innerWidth() - 2 * dxy[0];
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server2.setDesktopSize(width, height);
								resizeMaximizedWindows($server2, $element);
								functionExecuted2 = true;
							} catch (error) {
								functionExecuted2 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted2 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			}
		});
	});
}

function clipboardActive(active) {
	CLIPBOARD_ACTIVE = active;
	if (CLIPBOARD_ACTIVE) {
		$($.id(CLIPBOARD_ID)).focus().blur(function() {
			$(this).focus();
		});
		$('[role="log"]').remove();
	} else {
		$($.id(CLIPBOARD_ID)).off('blur').off('focus');
	}
}

function clipboardData(data) {
	CLIPBOARD_DATA = data;
	CLIPBOARD_DATA_WAITING = true;
}

function closeAllWindows(masterDiv) {
	$(document).ready(function() {
		if (masterDiv !== null) {
			CANVAS = {};
			DRAWING_DATA_TIMER.stop();
			DRAWING_DATA_RUNNING = false;
			DRAWING_DATA_TIMER_RUNNING = false;
			KEYBOARD_CAPS_LOCK = null; 
			KEYBOARD_NUM_LOCK = null;
			WINDOW_FOCUSED = '';
			WINDOWS_VISIBLE = false;
			WINDOW_TITLE_BAR_BUTTON_IMAGE = {};
			WINDOW_TITLE_BAR_ICON_IMAGE = {};
			
			// remove all windows
			$('[id^="' + masterDiv.id + '-"]').each(function() {
				$(this).remove();
			});

			// remove all overlay windows
			$($.id(masterDiv.id)).find('[class~="' + DIALOG_OVERLAY + '"]').remove();
		}
	});
}

function closeWindow(masterDiv, id) {
	$(document).ready(function() {
		if (masterDiv !== null) {
			var canvasDivId = masterDiv.id + '-' + id;
			var $canvasDiv = $($.id(canvasDivId));
			var $masterDiv = $($.id(masterDiv.id));

			// remove overlay and canvas window
			if ($canvasDiv.parent().hasClass('ui-dialog-DIALOG')) {
				$masterDiv.find('[class~="' + DIALOG_OVERLAY + '"]').remove();
			}
			$canvasDiv.remove();

			delete CANVAS[canvasDivId];
			delete CLIPBOARD_ENABLED[canvasDivId];
			delete WINDOW_TITLE_BAR_BUTTON_IMAGE[canvasDivId + DRAWING_DATA_CANVAS_ID];
			delete WINDOW_TITLE_BAR_ICON_IMAGE[canvasDivId + DRAWING_DATA_CANVAS_ID];
		}
	});
}

function createNewWindow(masterDiv, id, parentId, title, x, y, width, height, windowType, overrideRedirect, clipboardEnabled, autoCenterWindow) {
	$(document).ready(function() {
		var canvasDivId = masterDiv.id + '-' + id;
		if (masterDiv !== null && $($.id(canvasDivId)).length === 0) {
			CLIPBOARD_ENABLED[canvasDivId] = clipboardEnabled;
			OFFSCREEN_CANVAS = document.createElement(DRAWING_DATA_CANVAS);
			OFFSCREEN_CANVAS_CONTEXT = OFFSCREEN_CANVAS.getContext('2d');
			WINDOWS_VISIBLE = windowType !== WINDOW_TYPE.DEFAULT && windowType !== WINDOW_TYPE.NORMAL;

			// change to WINDOW_TYPE.DIALOG if window type is WINDOW_TYPE.NORMAL and has a parent window
			windowType = !overrideRedirect && windowType === WINDOW_TYPE.NORMAL && parentId > 0 ? WINDOW_TYPE.DIALOG : windowType;
			var showButtons = windowType === WINDOW_TYPE.DEFAULT || windowType === WINDOW_TYPE.NORMAL; // || windowType === WINDOW_TYPE.DIALOG || windowType === WINDOW_TYPE.UTILITY;

			// create new window
			var $mainDiv = $($.id(masterDiv.id));
			var $canvasDiv = $('<div/>').attr('id', canvasDivId).css({
				margin: '0px',
				padding: '0px'
			});
			$mainDiv.append($canvasDiv);

			// canvas div
			$canvasDiv.dialog({
				appendTo: $.id(masterDiv.id),
				beforeClose: function(event, ui) {
					var mainId = this.id.split('-');
					var id = mainId.pop();
					var $server1 = getServer($($.id(mainId.join('-'))));
					if ($server1 !== undefined) {
						var functionExecuted1 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server1.setWindowClosed(id);
									disableBars(true);
									functionExecuted1 = true;
								} catch (error) {
									functionExecuted1 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted1 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);				
					}
					return false;
				},
				closeOnEscape: false,
				closeText: '',
				draggable: true,
				height: 'auto',
				iconButtons: [
	                {
	                	clazz: 'maximize',
	                    click: function(event) {
	                    	if (!$(this).hasClass('disable')) {
		                    	var $mainDiv = $(this).parent().parent();
		                    	var $canvasDiv = $mainDiv.find('canvas[id]').parent();
		                    	$canvasDiv.triggerHandler('dialogmaximize');
	                    	}
	                    	clipboardActive(CLIPBOARD_ENABLED[canvasDivId]);
	                    },
	                	disabled: false,
	                    icon: 'ui-icon-extlink',
	                    show: showButtons
	                },
	                {
	                	clazz: 'restore disable',
	                    click: function(event) {
	                    	if (!$(this).hasClass('disable')) {
		                    	var $mainDiv = $(this).parent().parent();
		                    	var $canvasDiv = $mainDiv.find('canvas[id]').parent();
		                    	$canvasDiv.triggerHandler('dialogrestore');
	                    	}
	                    	clipboardActive(CLIPBOARD_ENABLED[canvasDivId]);
	                    },
	                	disabled: false,
	                    icon: 'ui-icon-newwin',
	                    show: showButtons
	                }
	            ],
				modal: false,
				open: function() {
					if (windowType === WINDOW_TYPE.DIALOG) {
						// add overlay window before the canvas's parent element
						var $masterDiv = $($.id(masterDiv.id));
						$('<div/>').addClass(DIALOG_OVERLAY).addClass('ui-front').css({
							height: $masterDiv.innerHeight(),
							width: $masterDiv.innerWidth()
						}).insertBefore($canvasDiv.parent());
						// set z-index
						var zIndex = parseInt($($.id(masterDiv.id + '-' + parentId)).parent().css('z-index'));
						$canvasDiv.parent().css('z-index', zIndex + 20);
					}
				},
				resizable: false,
				title: title,
				width: width
			}).parent().css({
				left: x,
				top: y
			}).mousedown(function(event) {
				if ($(event.target).hasClass('ui-dialog-titlebar') || $(event.target).hasClass('ui-dialog-title') || $(event.target).hasClass('ui-resizable-handle')) {
					var classUtility = DIALOG_CLASS + WINDOW_TYPE.UTILITY;
					var $window = $(event.target).closest('div[class~="ui-dialog"]');
					var $windowUtility = $window.parent().children('div[class~="' + classUtility + '"]');
					if ($windowUtility.length > 0 && !$window.hasClass('ui-dialog-DIALOG')) {
						// move normal window before utility window only if it
						// exists
						$windowUtility.first().before($window);				
					} else {
						$window.parent().find('[class*="ui-dialog-titlebar-focus"]').removeClass('ui-dialog-titlebar-focus');
						$window.children().first().addClass('ui-dialog-titlebar-focus');
						$window.appendTo($window.parent());
					}

					var currentId = $window.find('div[id]').attr('id');
					if (WINDOW_FOCUSED !== currentId) {
						var mainId = currentId.split('-');
						var id = mainId.pop();
						var $server2 = getServer($($.id(mainId.join('-'))));
						if ($server2 !== undefined) {
							var functionExecuted2 = false;
							setTimeout(function run() {
								if (!isAnotherRequestActive()) {
									try {
										$server2.setWindowFocus(id);
										functionExecuted2 = true;
									} catch (error) {
										functionExecuted2 = false;
									}
								}
								// function is not executed, let's try again
								if (functionExecuted2 === false) {
									setTimeout(run, REQUEST_ANOTHER_INTERVAL);
								}
							}, REQUEST_FIRST_INTERVAL);				
						}
					}
				}
			}).on('mousemove mouseover', function() {
				var $canvasDiv = $(this).find('div[id]').first();
				var canvasDivId = $canvasDiv.attr('id');
				if (!canvasDivId.isEmpty()) {
					var mainId = canvasDivId.split('-');
					var id = mainId.pop();
					$($.clazz('canvas-ui')).attr('id', id);
				}
			});

			// canvas element
			var $canvas = $(DRAWING_DATA_CANVAS_ELEMENT).attr({
				height: height,
				id: canvasDivId + DRAWING_DATA_CANVAS_ID,
				width: width
			}).on('mousemove mouseover', function(event) {
				if (this.parentElement !== null && this.parentElement !== undefined && this.parentElement.id !== null && this.parentElement.id !== undefined) {
					var canvasDivId = this.parentElement.id;
					if (!canvasDivId.isEmpty()) {
						var mainId = canvasDivId.split('-');
						var id = mainId.pop();
						$($.clazz('canvas-ui')).attr('id', id);
					}
				}
			}).mousedown(function(event) {
				var canvasDivId = this.parentElement.id;
				if (!canvasDivId.isEmpty()) {
					// window's focus has wrong id
					if (WINDOW_FOCUSED !== canvasDivId) {
						var mainId = canvasDivId.split('-');
						var id = mainId.pop();
						var $server6 = getServer($($.id(mainId.join('-'))));
						if ($server6 !== undefined) {
							var functionExecuted6 = false;
							setTimeout(function run() {
								if (!isAnotherRequestActive()) {
									try {
										$server6.setWindowFocus(id);
										functionExecuted6 = true;
									} catch (error) {
										functionExecuted6 = false;
									}
								}
								// function is not executed, let's try again
								if (functionExecuted6 === false) {
									setTimeout(run, REQUEST_ANOTHER_INTERVAL);
								}
							}, REQUEST_FIRST_INTERVAL);				
						}
					}
				}
			});
			$canvasDiv.css({
				height: height,
				overflow: 'hidden',
				width: width
			}).append($canvas);
			if (windowType !== WINDOW_TYPE.DEFAULT) {
				$canvasDiv.parent().addClass(DIALOG_CLASS + windowType);
			}

			// canvas object
			CANVAS[canvasDivId] = $canvas[0];

			var dxy = calculateDxy(canvasDivId);
			if (overrideRedirect || windowType === WINDOW_TYPE.SPLASH || windowType === WINDOW_TYPE.TOOLBAR || windowType === WINDOW_TYPE.TOOLTIP) {
				$canvasDiv.parent().css({
					backgroundColor: 'transparent',
					border: 'none',
					left: x + dxy[0],
					margin: '0px',
					padding: '0px',
					top: y + dxy[1] + dxy[2],
					width: 'auto'
				}).children().first().hide();
				$canvasDiv.parent().removeClass('ui-corner-all').find($.clazz('ui-resizable-se')).remove();
				
				if (overrideRedirect || windowType === WINDOW_TYPE.SPLASH) {
					var $windowFocused = $($.id(WINDOW_FOCUSED)).parent();
					var zIndex = getInteger($windowFocused.css('zIndex')) || 150;
					if (windowType === WINDOW_TYPE.SPLASH) {
						$canvasDiv.parent().css('zIndex', zIndex);
					} else {
						$canvasDiv.parent()
							.css('zIndex', zIndex)
							.addClass('ui-dialog-OVERRIDE-REDIRECT');
					}
				}

				if (windowType === WINDOW_TYPE.DIALOG || windowType === WINDOW_TYPE.SPLASH) {
					if (windowType === WINDOW_TYPE.SPLASH) {
						$canvasDiv.dialog('option', 'position', {my: 'center', at: 'center', of: $mainDiv});
					}
					var $server8 = getServer($mainDiv);
					if ($server8 !== undefined) {
						var functionExecuted8 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									var position = $canvasDiv.parent().position();
									var w = $canvasDiv.children().first().innerWidth();
									var h = $canvasDiv.children().first().innerHeight();
									$server8.setWindowDimensions(id, position.left, position.top, w, h);
									functionExecuted8 = true;
								} catch (error) {
									functionExecuted8 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted8 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);				
					}
				}
			} else {
	        	// hide window
	        	if (!WINDOWS_VISIBLE) {
					$canvasDiv.parent().css('visibility', 'hidden');
	        	}

				clipboardActive(CLIPBOARD_ENABLED[canvasDivId]);
				$canvasDiv.dialog('option', 'draggable', true).parent()
					.draggable( 'option', 'containment', $.id(masterDiv.id) );
	        	$canvasDiv.dialog('option', 'resizable', true).parent()
	        		.resizable( 'option', 'containment', $.id(masterDiv.id) );
	
				// dialog event: drag stop
				$canvasDiv.on('dialogdragstop', function(event, ui) {
					var canvasDivId = this.id;
					var mainId = canvasDivId.split('-');
					var id = mainId.pop();
					var $mainDiv = $($.id(mainId.join('-')));
					var $server10 = getServer($mainDiv.parent());
					if ($server10 !== undefined) {
						var left = ui.position.left;
						var top = ui.position.top;
						var functionExecuted10 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server10.setWindowPosition(id, left, top);
									functionExecuted10 = true;
								} catch (error) {
									functionExecuted10 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted10 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);				
					}
				});
	
				// dialog event: maximize
				$canvasDiv.on('dialogmaximize', function(event) {
					var $this = $($.id(this.id));
					var canvasDivId = this.id;
					var mainId = canvasDivId.split('-');
					var id = mainId.pop();
					var $mainDiv = $($.id(mainId.join('-')));
					var dxy = calculateDxy(canvasDivId);
					var width = $mainDiv.innerWidth() - 2 * dxy[0];
					var height = $mainDiv.innerHeight() - 2 * dxy[1] - dxy[2];
					var $server11 = getServer($mainDiv.parent());
					$this.parent().parent().css('overflow', 'hidden');
					if ($server11 !== undefined) {
						var functionExecuted11 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									moveResizeWindow($mainDiv[0], id, 0, 0, width, height, true);
									$server11.setWindowMaximized(id, width, height, true);
									functionExecuted11 = true;
								} catch (error) {
									functionExecuted11 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted11 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);
					}
				});
	
				// dialog event: resize stop
				$canvasDiv.on('dialogresizestop', function(event, ui) {
					var canvasDivId = this.id;
					var mainId = canvasDivId.split('-');
					var id = mainId.pop();
					var $canvasDiv = $($.id(canvasDivId));
					var $mainDiv = $($.id(mainId.join('-')));
					var $server12 = getServer($mainDiv);
					if ($server12 !== undefined) {
						var left = ui.position.left;
						var top = ui.position.top;
						var width = $canvasDiv.innerWidth();
						var height = $canvasDiv.innerHeight();
						var functionExecuted12 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server12.setWindowDimensions(id, left, top, width, height);
									moveResizeWindow($mainDiv[0], id, left, top, width, height, false);
									functionExecuted12 = true;
								} catch (error) {
									functionExecuted12 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted12 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);
					}
				});
	
				// dialog event: restore
				$canvasDiv.on('dialogrestore', function(event, ui) {
					var $this = $($.id(this.id));
					$this.parent().parent().css('overflow', 'hidden');
					$canvasDiv.dialog('option', 'draggable', true).parent()
						.draggable( 'option', 'containment', $.id(masterDiv.id) );
		        	$canvasDiv.dialog('option', 'resizable', true).parent()
		        		.resizable( 'option', 'containment', $.id(masterDiv.id) );
					
					var canvasDivId = this.id;
					var mainId = canvasDivId.split('-');
					var id = mainId.pop();
					var $mainDiv = $($.id(mainId.join('-')));
					var $server13 = getServer($mainDiv);
					if ($server13 !== undefined) {
						var functionExecuted13 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server13.setWindowMaximized(id, 0, 0, false);
									functionExecuted13 = true;
								} catch (error) {
									functionExecuted13 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted13 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);
					}
				});

				if (autoCenterWindow || windowType === WINDOW_TYPE.DIALOG || windowType === WINDOW_TYPE.SPLASH) {
					$canvasDiv.dialog('option', 'position', {my: 'center', at: 'center', of: $mainDiv});

					if (windowType === WINDOW_TYPE.DIALOG) {
						setTimeout(function() {
							var zIndex = getInteger($canvasDiv.parent().css('zIndex'));
							var $canvasBlocker = $($.clazz(CANVAS_BLOCKER_CLASS));
							if ($canvasBlocker.length !== 0) {
								$canvasBlocker.css('zIndex', zIndex - 1);
							}
						}, BARS_DISABLED_DELAY);
					}

					var $server14 = getServer($mainDiv);
					if ($server14 !== undefined) {
						var pos = $canvasDiv.parent().position();
						var ww = $canvasDiv.children().first().innerWidth();
						var hh = $canvasDiv.children().first().innerHeight();
						var functionExecuted14 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server14.setWindowDimensions(id, pos.left, pos.top, ww, hh);
									functionExecuted14 = true;
								} catch (error) {
									functionExecuted14 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted14 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);
						var functionExecuted15 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server14.setWindowPosition(id, pos.left, pos.top);
									functionExecuted15 = true;
								} catch (error) {
									functionExecuted15 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted15 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, WINDOW_POSITION_DELAY);
					}
				}

				// move normal window before utility window
				if (windowType === WINDOW_TYPE.DEFAULT || windowType === WINDOW_TYPE.NORMAL) {
					var classUtility = DIALOG_CLASS + WINDOW_TYPE.UTILITY;
					var $windowUtility = $canvasDiv.parent().parent().children('div[class~="' + classUtility + '"]');
					if ($windowUtility.length !== 0) {
						$windowUtility.first().before($canvasDiv.parent());
					}
				}

				// title bar buttons
				WINDOW_TITLE_BAR_BUTTON_IMAGE[canvasDivId + DRAWING_DATA_CANVAS_ID] = [];
				var $titleBar = $($.id(canvasDivId)).parent().children('div.ui-dialog-titlebar');
				var $titleBarButtons = $titleBar.find('button.ui-button');
				$titleBarButtons.each(function() {
					var $icon = $(this).find('span.ui-icon');
					var image = new Image();
					image.src = $icon.css('backgroundImage').slice(4, -1).replace(/['"]/g, '');
					WINDOW_TITLE_BAR_BUTTON_IMAGE[canvasDivId + DRAWING_DATA_CANVAS_ID].push(image);
				});
				WINDOW_SCREENSHOT_IMAGE = new Image();
				WINDOW_SCREENSHOT_IMAGE.src = 'frontend/img/typicons-camera-outline.png';
				WINDOW_LOGO_IMAGE = new Image();
				WINDOW_LOGO_IMAGE.src = 'frontend/img/dVirtual.png';
			}

			// window dimensions properties
			var $server16 = getServer($mainDiv);
			if ($server16 !== undefined) {
				var functionExecuted16 = false;
				var offset = $mainDiv.offset();
				var dxy = calculateDxy(canvasDivId);
				var borderWidth = getInteger($mainDiv.parent().css('borderTopWidth'));
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server16.setWindowDimensionsProperties(id, dxy[0], dxy[1], dxy[2], offset.left, offset.top, borderWidth);
							functionExecuted16 = true;
						} catch (error) {
							functionExecuted16 = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted16 === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);				
			}

			// remove unnecessary style
			$canvasDiv.css({
				'min-height': '',
				'min-width': '',
				'max-height': '',
				'max-widht': ''
			});
		}
	});
}

function disableBars(disable) {
	if (disable) {
		setTimeout(function() {
			var $blocker = $($.clazz(FULL_SCREEN ? 'canvas-ui' : 'dvirtual-layout'));
			$('<div/>').addClass(CANVAS_BLOCKER_CLASS).css({
				height: $blocker.innerHeight() - 1,
				width: $blocker.innerWidth() - 1
			}).appendTo($blocker);		
		}, BARS_DISABLED_DELAY);
	} else {
		setTimeout(function() {
			$($.clazz(CANVAS_BLOCKER_CLASS)).remove();
			if (FULL_SCREEN) {
				$('vaadin-dialog-overlay').appendTo($($.clazz(FULL_SCREEN_ELEMENT_CLASS)));
			}
		}, BARS_ENABLED_DELAY);
	}
}

function drawCanvas(masterDiv, id, drawingData) {
	if (masterDiv !== null) {
		DRAWING_DATA_QUEUE.push(masterDiv.id + '-' + id, drawingData);
		setTimeout(drawingCanvasProcessor, REQUEST_FIRST_INTERVAL);
	}
}

function drawCursor(masterDiv, id, x, y, cursorData, encoding) {
	setTimeout(function() {
		if (masterDiv !== null) {
			if (id < 0) {
				// reset all cursors
				$('[id|="' + masterDiv.id + '"][id$="' + DRAWING_DATA_CANVAS_ID + '"]').css('cursor', 'default');
			} else if (encoding === DRAWING_DATA_UNDEFINED) {
				// reset cursor of the active window
				$($.id(masterDiv.id + '-' + id + DRAWING_DATA_CANVAS_ID)).css('cursor', 'default');
			} else {
				// draw cursor
				var cursorImage = 'data:image/' + encoding + ';base64,' + cursorData;
				$('[id|="' + masterDiv.id + '"][id$="' + DRAWING_DATA_CANVAS_ID + '"]')
					.css('cursor', 'url("' + cursorImage + '"), default')
					.css('cursor', 'url("' + cursorImage + '") ' + x + ' ' + y + ', auto');
			}
		}
	}, REQUEST_FIRST_INTERVAL);
}

function drawingCanvas() {
	// drawingDataQueue[0] - id
	// drawingDataQueue[1] - drawing data
	DRAWING_DATA_RUNNING = true;

	var drawingDataQueue = DRAWING_DATA_QUEUE.slice(0, DRAWING_DATA_QUEUE_STEP);
	if (CANVAS[drawingDataQueue[0]] !== undefined) {
		drawingCanvasData(drawingDataQueue);
	}

	// remove drawing data from queue
	DRAWING_DATA_QUEUE.splice(0, DRAWING_DATA_QUEUE_STEP);
	if (DRAWING_DATA_TIMER_RUNNING && DRAWING_DATA_QUEUE.length === 0) {
		DRAWING_DATA_TIMER_RUNNING = false;
		DRAWING_DATA_TIMER.stop();
	}

	DRAWING_DATA_RUNNING = false;
}

function drawingCanvasData(drawingDataQueue) {
	// drawingDataQueue[0] - id
	// drawingDataQueue[1] - drawing data
	var canvasId = drawingDataQueue[0];
	var dataArray = drawingDataQueue[1].split(ARRAY_SPLITTER);
	var id = canvasId.split('-').pop();
	var $server = getServer(CANVAS[canvasId]);
	var canvasData, data, dataType, drawingData, index, x, y, width, height, rowStride, sequence;

	for (index = 0; index < dataArray.length; index++) {
		data = dataArray[index].split(ARRAY_ELEMENT_SPLITTER);
		if (data.length === 8) {
			x = data[0];
			y = data[1];
			width = data[2];
			height = data[3];
			rowStride = data[4];
			sequence = data[5];
			drawingData = data[6];
			dataType = data[7];

			// prepare data
			var frameStart = Date.now();
			switch (dataType) {
				case DRAWING_DATA_TYPE_JPEG:
				case DRAWING_DATA_TYPE_PNG:
				case DRAWING_DATA_TYPE_RGB:
				case DRAWING_DATA_TYPE_RGB32_ZLIB:
				case DRAWING_DATA_TYPE_WEBP:
					// nothing to do
					break;
				case DRAWING_DATA_TYPE_H264:
				case DRAWING_DATA_TYPE_RGB32:
					drawingData = JSON.parse(drawingData);
					break;
				case DRAWING_DATA_TYPE_RGB32_LZ4:
					canvasData = JSON.parse(drawingData);
					var d = canvasData.subarray ? canvasData.subarray(0, 4) : canvasData.slice(0, 4);
					var length = d[0] | (d[1] << 8) | (d[2] << 16) | (d[3] << 24);
					var dataBuffer = new LZ4_BUFFER(length);
					var uncompressedSize = LZ4.decodeBlock(canvasData.subarray ? canvasData.subarray(4) : canvasData.slice(4), dataBuffer);
					drawingData = dataBuffer.slice(0, uncompressedSize);
					break;
				case DRAWING_DATA_TYPE_SCROLL:
					drawingData = String.fromCharCode.apply(null, JSON.parse(drawingData));
					drawingData = JSON.parse(drawingData);
					break;
				case DRAWING_DATA_UNDEFINED:
				default:
					break;
			}

			// draw data
			switch (dataType) {
				case DRAWING_DATA_TYPE_JPEG:
				case DRAWING_DATA_TYPE_PNG:
				case DRAWING_DATA_TYPE_RGB:
				case DRAWING_DATA_TYPE_WEBP:
					drawingCanvasImageOnLoad(CANVAS[canvasId], x, y, 'data:image/' + dataType + ';base64,' + drawingData);
					break;
				case DRAWING_DATA_TYPE_RGB32:
				case DRAWING_DATA_TYPE_RGB32_LZ4:
				case DRAWING_DATA_TYPE_RGB32_ZLIB:
					drawingCanvasImageOffScreen(CANVAS[canvasId], x, y, width, height, rowStride, drawingData)
					break;
				case DRAWING_DATA_TYPE_SCROLL:
					drawingCanvasImageOnScroll(CANVAS[canvasId], drawingData);
					break;
				case DRAWING_DATA_TYPE_H264:
				case DRAWING_DATA_TYPE_RGB_ZLIB:
				case DRAWING_DATA_UNDEFINED:
				default:
					console.error('Unsupported data type: ' + dataType);
					break;
			}

			// sequence
			var frameStop = Date.now();
			var frameTime = (frameStop - frameStart) * DRAWING_DATA_FRAME_TIME_FACTOR;
			frameTime = Math.max(DRAWING_DATA_FRAME_TIME_FACTOR, frameTime);
			DRAWING_DATA_SEQUENCE.push(id, width, height, sequence, frameTime);
			drawingCanvasSequenceProcessor($server);
		}
	}
}

function drawingCanvasImageOffScreen(canvas, x, y, width, height, rowStride, canvasData) {
	OFFSCREEN_CANVAS_CONTEXT.imageSmoothingEnabled = false;
	var currentRowStride = width * 4;
	var canvasImage = OFFSCREEN_CANVAS_CONTEXT.createImageData(width, height);
	var canvasContext = canvas.getContext('2d');
	canvasContext.imageSmoothingEnabled = false;
	if (rowStride > currentRowStride) {
		for (var index = 0; index < height; index++) {
			var canvasLine = new Uint8Array(canvasData.buffer, index * rowstride, currentRowStride);
			canvasImage.data.set(canvasLine, index * currentRowStride);
		}
	} else {
		canvasImage.data.set(canvasData);
	}
	canvasContext.clearRect(x, y, width, height);
	canvasContext.putImageData(canvasImage, x, y);
}

function drawingCanvasImageOnLoad(canvas, x, y, src) {
	var canvasContext = canvas.getContext('2d');
	var image = new Image();
	canvasContext.imageSmoothingEnabled = false;
	image.onload = function() {
		canvasContext.clearRect(x, y, image.width, image.height);
		canvasContext.drawImage(image, x, y);
	};
	image.src = src;
}

function drawingCanvasImageOnScroll(canvas, canvasData) {
	var canvasContext = canvas.getContext('2d');
	for (var index = 0; index < canvasData.length; index++) {
		var data = canvasData[index];
		var sX = data[0];
		var sY = data[1];
		var sWidth = data[2];
		var sHeight = data[3];
		var dWidth = data[4];
		var dHeight = data[5];
		canvasContext.drawImage(canvas, sX, sY, sWidth, sHeight, sX + dWidth, sY + dHeight, sWidth, sHeight);
	}
}

function drawingCanvasProcessor() {
	if (DRAWING_DATA_RUNNING) {
		if (!DRAWING_DATA_TIMER_RUNNING) {
			DRAWING_DATA_TIMER_RUNNING = true;
			DRAWING_DATA_TIMER.start();
		}
	} else {
		DRAWING_DATA_RUNNING = true;
		if (!DRAWING_DATA_TIMER_RUNNING && DRAWING_DATA_QUEUE.length > 1) {
			DRAWING_DATA_TIMER_RUNNING = true;
			DRAWING_DATA_TIMER.start();
		}
		drawingCanvas();			
	}
}

function drawingCanvasSequenceProcessor($server) {
	if ($server !== undefined) {
		var functionExecuted = false;
		setTimeout(function run() {
			if (!isAnotherRequestActive()) {
				try {
					var drawingDataSequence = DRAWING_DATA_SEQUENCE.splice(0, DRAWING_DATA_SEQUENCE_STEP);
					if (drawingDataSequence.length === DRAWING_DATA_SEQUENCE_STEP) {
						var id = drawingDataSequence[0];
						var width = drawingDataSequence[1];
						var height = drawingDataSequence[2];
						var sequence = drawingDataSequence[3];
						var frameTime = drawingDataSequence[4];
						$server.setDamageSequence(id, width, height, sequence, frameTime);
					}
					functionExecuted = true;
				} catch (error) {
					functionExecuted = false;
				}
			}
			// function is not executed, let's try again
			if (functionExecuted === false) {
				setTimeout(run, REQUEST_ANOTHER_INTERVAL);
			}
		}, REQUEST_FIRST_INTERVAL);				
	}
}

function drawWindowIcon(masterDiv, id, iconData) {
	$(document).ready(function() {
		if (masterDiv !== null && !iconData.isEmpty()) {
			var $masterDiv = $($.id(masterDiv.id + '-' + id));
			var canvasImage = OFFSCREEN_CANVAS_CONTEXT.createImageData(20, 20);
			var iconImage = 'data:image/png;base64,' + iconData;
			var image = new Image();
			image.onload = function() {
				canvasImage.drawImage(image, 0, 0);
			};
			$masterDiv.parent()
				.children()
				.first()
				.attr('style', 'padding-left: 2.3em !important')
				.prepend($('<span><img/></span>').addClass(DIALOG_TITLE_ICON));
			$masterDiv.parent()
				.find($.clazz(DIALOG_TITLE_ICON))
				.children()
				.first()
				.attr('src', iconImage);
			WINDOW_TITLE_BAR_ICON_IMAGE[masterDiv.id + '-' + id + DRAWING_DATA_CANVAS_ID] = new Image();
			WINDOW_TITLE_BAR_ICON_IMAGE[masterDiv.id + '-' + id + DRAWING_DATA_CANVAS_ID].src = iconImage;
		}
	});
}

function fullScreenFinal() {
	// !!! DO NOT CHANGE THE ORDER - START !!!
	var $fullScreen = $($.clazz(FULL_SCREEN_ELEMENT_CLASS));
	if (!FULL_SCREEN) {
		var $body = $('body');
		$('div.v-loading-indicator').prependTo($body);
		$('vaadin-dialog-overlay').appendTo($body);
		$fullScreen.removeClass('no-border-fullscreen');
	} else {
		$fullScreen.addClass('no-border-fullscreen');	
		$('div.v-loading-indicator').prependTo($fullScreen);
		$('vaadin-dialog-overlay').appendTo($fullScreen);
		
		// send new desktop size
		var $server = getServer($fullScreen);
		if ($server !== undefined) {
			var functionExecuted = false;
			setTimeout(function run() {
				if (!isAnotherRequestActive()) {
					try {
						var $element = $(element);
						$server.setDesktopSize($element.innerWidth(), $element.innerHeight());
						resizeMaximizedWindows($server, $element);
						functionExecuted = true;
					} catch (error) {
						functionExecuted = false;
					}
				}
				// function is not executed, let's try again
				if (functionExecuted === false) {
					setTimeout(run, REQUEST_ANOTHER_INTERVAL);
				}
			}, REQUEST_FIRST_INTERVAL);				
		}
	}
	// !!! DO NOT CHANGE THE ORDER - STOP !!!
}

function init(element) {
	$(document).ready(function() {
		// close browser tab/browser window event
		window.addEventListener('beforeunload', function (event) {
			var $server1 = getServer($(element));
			if ($server1 !== undefined) {
				var functionExecuted1 = false;
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server1.setBrowserClosed();
							functionExecuted1 = true;
						} catch (error) {
							functionExecuted1 = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted1 === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);				
			}
            return undefined;
        });

		// disable 'moveToTop' function
		$.ui.dialog.prototype._moveToTop = function() {
		    return true;
		};

		// clipboard element
		$('<div/>').css({
			display: 'block',
			filter: 'alpha(opacity=0)',
			left: '-99999px',
			opacity: '0',
			overflow: 'hidden',
			position: 'absolute',
			top: '-99999px'
		}).prepend($('<textarea/>').attr('id', CLIPBOARD_ID)).appendTo('body');
		$($.id(CLIPBOARD_ID)).on(CLIPBOARD_COPY + ' ' + CLIPBOARD_CUT, function() {
	        $(this).text(CLIPBOARD_DATA).select();
			CLIPBOARD_DATA_WAITING = false;
	        return true;
		}).on(CLIPBOARD_PASTE, function(event) {
			if (!WINDOW_FOCUSED.isEmpty()) { 
				var mainId = WINDOW_FOCUSED.split('-').slice(0, -1);
				var $server2 = getServer($($.id(mainId.join('-'))));
				CLIPBOARD_DATA = (event.originalEvent || event).clipboardData.getData(CLIPBOARD_TARGETS[3]);
				if ($server2 !== undefined) {
					var functionExecuted2 = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server2.setClipboardToken(CLIPBOARD_DATA);
								functionExecuted2 = true;
							} catch (error) {
								functionExecuted2 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted2 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			}
	        return false;
		}).on('input', function() {
			if (!WINDOW_FOCUSED.isEmpty()) { 
		   		var modifiers = [].toString()
				var mainId = WINDOW_FOCUSED.split('-');
				var id = mainId.pop();
				var $server3 = getServer($($.id(mainId.join('-'))));
				var $this = $(this);
				CLIPBOARD_DATA = $this.val();
		   		$this.val('');
				if ($server3 !== undefined) {
					var functionExecuted3 = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
					   			var keyString = CLIPBOARD_DATA[0];
					   			var keyCode = keyString.charCodeAt(0);
					   			var keyName = keyString;
					   			var keyValue = keyCode;
				   				$server3.setKeyClick(id, keyCode, keyValue, keyName, keyString, modifiers, true, false);
					   			CLIPBOARD_DATA = CLIPBOARD_DATA.substring(1);
								functionExecuted3 = CLIPBOARD_DATA.length === 0;
							} catch (error) {
								functionExecuted3 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted3 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			}
	   	});
		$('body').on('click', function() {
			if (CLIPBOARD_DATA_WAITING) {
		        $($.id(CLIPBOARD_ID)).text(CLIPBOARD_DATA).select();
				// for MS Windows
				var success = true;
				if (window.clipboardData && window.clipboardData.setData) {
					window.clipboardData.setData(CLIPBOARD_TARGETS[1], CLIPBOARD_DATA);
				} else {
					success = document.execCommand(CLIPBOARD_COPY);
				}
				if (success) {
					CLIPBOARD_DATA_WAITING = false;
				}
			}
		});
		clipboardActive(CLIPBOARD_ACTIVE);

		// remove all tooltips when leaving canvas div element
		$(element).mouseleave(function() {
			$(this).find('[class*="ui-dialog-TOOLTIP"]').each(function() {
				var $tooltip = $(this).children('div').eq(1);
				var divId = $tooltip.attr('id');
				var mainId = divId.split('-');
				var id = mainId.pop();
				var $server4 = getServer($($.id(mainId.join('-'))));
				if ($server4 !== undefined) {
					var functionExecuted4 = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server4.setWindowClosed(id);
								functionExecuted4 = true;
							} catch (error) {
								functionExecuted4 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted4 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			});
		});

		// full screen mode
		if ($.fullscreen.isNativelySupported()) {
			$($.clazz(FULL_SCREEN_ELEMENT_CLASS)).on('webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange', function() {
				FULL_SCREEN = $.fullscreen.isFullScreen();
				fullScreenFinal();
				fullScreenProcessor(FULL_SCREEN, true);
				var $server7 = getServer($(element));
				if ($server7 !== null) {
					var functionExecuted7 = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server7.setFullScreen(FULL_SCREEN);
								functionExecuted7 = true;
							} catch (error) {
								functionExecuted7 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted7 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			});
			$($.clazz(FULL_SCREEN_BUTTON_CLASS)).on('click', function(event) {
				FULL_SCREEN = !$.fullscreen.isFullScreen();
				fullScreenFinal();
				fullScreenProcessor(FULL_SCREEN, false);
				var $server8 = getServer($(element));
				if ($server8 !== null) {
					var functionExecuted8 = false;
					setTimeout(function run() {
						if (!isAnotherRequestActive()) {
							try {
								$server8.setFullScreen(FULL_SCREEN);
								functionExecuted8 = true;
							} catch (error) {
								functionExecuted8 = false;
							}
						}
						// function is not executed, let's try again
						if (functionExecuted8 === false) {
							setTimeout(run, REQUEST_ANOTHER_INTERVAL);
						}
					}, REQUEST_FIRST_INTERVAL);				
				}
			});
		} else {
			var $server9 = getServer($(element));
			if ($server9 !== null) {
				var functionExecuted9 = false;
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server.setFullScreenStatus(false);
							functionExecuted9 = true;
						} catch (error) {
							functionExecuted9 = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted9 === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);				
			}
		}
		
		// timer for data drawing
		if (DRAWING_DATA_TIMER === null) {
			prepareDrawingDataTimer()
		}
		
		// capture browser's visibility
		this.addEventListener('visibilitychange', function (event) {
			var $server10 = getServer($(element));
			if ($server10 !== undefined) {
				var functionExecuted10 = false;
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server10.setBrowserHidden(document.hidden);
							functionExecuted10 = true;
						} catch (error) {
							functionExecuted10 = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted10 === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);
			}
		});

		// disable running applications bar
		$($.clazz('running-applications-bar')).on('mouseup', $.clazz('running-application'), function() {
			if (!$(this).is('[selected]')) {
				disableBars(true);
			}
		}).on('mouseup', $.clazz('title'), function() {
			if ($(this).parents($.clazz('running-application')).first().is('[selected]')) {
				disableBars(true);
			}
		});

		// disable applications bar
		$($.clazz('applications-bar')).on('mouseup', $.clazz('application'), function() {
			disableBars(true);
		});

		// show Vaadin tooltip in full screen mode
		$($.clazz('applications-bar')).on('mouseenter', 'vaadin-tab', function() {
			showTooltip();
		});
		$($.clazz('bars-layout')).on('mouseenter', $.clazz('close'), function() {
			showTooltip();
		}).on('mouseenter', $.clazz('maximize'), function() {
			showTooltip();
		}).on('mouseenter', $.clazz('restore'), function() {
			showTooltip();
		}).on('mouseenter', 'vaadin-button', function() {
			showTooltip();
		});

		// key events
		$(window).keydown(function(event) {
			// disable tab key
			var keyCode = event.which ? event.which : event.keyCode;
			if (keyCode === 9) {
			    event.preventDefault();
				return false;
			} else if (keyCode === 122) {
				// full screen mode, function key F11
				event.stopPropagation();
			    event.preventDefault();
				$($.clazz(FULL_SCREEN_BUTTON_CLASS)).click();
				return false;
			}
		})

		// keyboard capslock and numlock status
		KEYBOARD_CAPS_LOCK = null; 
		KEYBOARD_NUM_LOCK = null;
		$($.clazz('canvas-ui')).attr('id', ZERO_WINDOW_ID);
		$(window).mousemove(function(event) {
			if (KEYBOARD_CAPS_LOCK === null || KEYBOARD_NUM_LOCK === null) {
				var $server12 = getServer($(element));
				keyboardAndMouseProperties($server12, event);
			}
		}).mouseleave(function() {
			KEYBOARD_CAPS_LOCK = null; 
			KEYBOARD_NUM_LOCK = null;
		});
	});
}

function keyboardAndMouseProperties($server, event) {
	if (KEYBOARD_CAPS_LOCK === null || KEYBOARD_NUM_LOCK === null) {
		KEYBOARD_CAPS_LOCK = ''; 
		KEYBOARD_NUM_LOCK = '';
		if (event.originalEvent.getModifierState) {
			if (event.originalEvent.getModifierState(MODIFIER_CAPS_LOCK)) {
				KEYBOARD_CAPS_LOCK = event.originalEvent.getModifierState(MODIFIER_CAPS_LOCK);
			}
			if (event.originalEvent.getModifierState(MODIFIER_NUM_LOCK)) {
				KEYBOARD_NUM_LOCK = event.originalEvent.getModifierState(MODIFIER_NUM_LOCK)
			}

			// mouse wheel event id
			var mouseWheelEventId = null;
			if (mouseWheelEventSupported('wheel')) {
				mouseWheelEventId = 'wheel';
			}
			else if (mouseWheelEventSupported('mousewheel')) {
				mouseWheelEventId = 'mousewheel';
			}
			else if (mouseWheelEventSupported('DOMMouseScroll')) {
				// for Mozilla Firefox
				mouseWheelEventId = 'DOMMouseScroll';
			}

			// send keyboard status data
			if ($server !== undefined) {
				var functionExecuted = false;
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server.setKeyboardAndMouseProperties(KEYBOARD_CAPS_LOCK !== '' ? true : false, KEYBOARD_NUM_LOCK !== '' ? true : false, mouseWheelEventId);
							functionExecuted = true;
						} catch (error) {
							functionExecuted = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);
			}
		}
	}
}

function mouseWheelEventSupported(event) {
	var testedMouseEvent = 'on' + event;
	var testedElement = document.createElement('div');
	var mouseWheelSupported = testedMouseEvent in testedElement;

	if (!mouseWheelSupported) {
		testedElement.setAttribute(testedMouseEvent, 'return;');
		mouseWheelSupported = typeof testedElement[testedMouseEvent] === 'function';
	}
	testedElement.remove();
	
	return mouseWheelSupported;
}

function moveResizeWindow(masterDiv, id, x, y, width, height, windowMaximized) {
	$(document).ready(function() {
		if (masterDiv !== null) {
			var canvasDivId = masterDiv.id + '-' + Math.abs(id);
			if ($($.id(canvasDivId)).length) {
				var $mainDiv = $($.id(masterDiv.id));
				var $canvasDiv = $($.id(canvasDivId));
	        	var $canvas = $canvasDiv.children()[0];
				var canvasContext = $canvas.getContext('2d');
				var dialogWindowHeaderVisible = $canvasDiv.parent().children().first().is(':visible');
				var dxy = calculateDxy(canvasDivId);
				var xx = windowMaximized ? 0 : Math.max(0, x);
				var yy = windowMaximized ? 0 : Math.max(0, y);
				var isDndWindow = $canvasDiv.parent().hasClass('ui-dialog-DND');
				var isOverrideDirectWindow = $canvasDiv.parent().hasClass('ui-dialog-OVERRIDE-REDIRECT');
	
				if (windowMaximized) {
					// window is maximized
					$canvasDiv.parent().find('[class~="maximize"]').addClass('disable');
					$canvasDiv.parent().find('[class~="restore"]').removeClass('disable');
		        	$canvasDiv.dialog('option', 'draggable', false);
		        	$canvasDiv.dialog('option', 'resizable', false);
		        	
		        	// set canvas scale
					var widthMaximized = Math.floor($mainDiv.innerWidth() - 2 * dxy[0]);
					var heightMaximized = Math.floor($mainDiv.innerHeight() - 2 * dxy[1] - dxy[2]);
					canvasContext.scale(widthMaximized/width, heightMaximized/height);
					width = widthMaximized;
					height = heightMaximized;
				} else if (dialogWindowHeaderVisible) {
					// window is normal
					$canvasDiv.parent().find('[class~="maximize"]').removeClass('disable');
					$canvasDiv.parent().find('[class~="restore"]').addClass('disable');
		        	$canvasDiv.dialog('option', 'draggable', true);
		        	$canvasDiv.dialog('option', 'resizable', true);

		        	// reset canvas scale
					canvasContext.setTransform(1, 0, 0, 1, 0, 0);
				}
	
				// !!! DO NOT CHANGE THE ORDER - START !!!
				// canvas element
				if(width > 0 && height > 0 && (!isOverrideDirectWindow || isDndWindow || $canvasDiv.innerWidth() !== width)) {
					var imageData = canvasContext.getImageData(0, 0, width, height);
					$($canvas).attr({
						height: height,
						width: width
					});

					// canvas div
					if (dialogWindowHeaderVisible) {
						$canvasDiv.innerWidth(width).innerHeight(height).parent().css({
							height: 'auto',
							left: xx,
							top: yy,
							width: width
						});
					} else {
						$canvasDiv.innerWidth(width).innerHeight(height).parent().css({
							height: 'auto',
							left: xx,
							top: yy + dxy[2],
							width: width
						});
					}
					canvasContext.putImageData(imageData, 0, 0);	
				}
				// !!! DO NOT CHANGE THE ORDER - STOP !!!
			}

			// remove overlay when window is restored/maximized
			$('div.ui-frozen').remove();
			$($.id(masterDiv.id)).css('overflow', windowMaximized ? 'hidden' : '');
		}
	});
}

function newWindowFocus(masterDiv, id) {
	$(document).ready(function() {
		if (masterDiv !== null && id > 0) {
			var focusId = masterDiv.id + '-' + id;
			var classDefault = DIALOG_CLASS + WINDOW_TYPE.DEFAULT;
			var classNormal = DIALOG_CLASS + WINDOW_TYPE.NORMAL;
			var classUtility = DIALOG_CLASS + WINDOW_TYPE.UTILITY;

			var $mainDiv = $($.id(masterDiv.id));
			var $windowFocused = $($.id(focusId)).parent();
			var $windowUtility = $windowFocused.parent().children('div[class~="' + classUtility + '"]');
			WINDOW_FOCUSED = focusId;

			if ($windowUtility.length !== 0 && ($windowFocused.is($('[class~="' + classDefault + '"]')) || $windowFocused.is($('[class~="' + classNormal + '"]')))) {
				// move normal window before utility window only if it exists
				$windowUtility.first().before($windowFocused);				
			} else {
				$windowFocused.appendTo($mainDiv);
			}

			// set window focus
			$mainDiv.find('[class*="ui-dialog-titlebar-focus"]').removeClass('ui-dialog-titlebar-focus');
			$windowFocused.children().first().addClass('ui-dialog-titlebar-focus');
			disableBars(false);
		}
	});
}

function newWindowTitle(masterDiv, id, title) {
	$(document).ready(function() {
		if (masterDiv !== null) {
			$($.id(masterDiv.id + '-' + id)).dialog('option', 'title', title);
			disableBars(false);
		}
	});
}

function pingFromBrowser(element) {
	var $server = getServer($(element));
	if ($server !== undefined) {
		var functionExecuted = false;
		setTimeout(function run() {
			if (!isAnotherRequestActive()) {
				try {
					$server.setPingFromBrowser(element.id);
					functionExecuted = true;
				} catch (error) {
					functionExecuted = false;
				}
			}
			// function is not executed, let's try again
			if (functionExecuted === false) {
				setTimeout(run, REQUEST_ANOTHER_INTERVAL);
			}
		}, REQUEST_FIRST_INTERVAL);
	}
}

function prepareDrawingDataTimer() {
	const { TaskTimer } = tasktimer;
	DRAWING_DATA_TIMER = new TaskTimer(DRAWING_DATA_TIMER_INTERVAL);
	DRAWING_DATA_TIMER.add([{
        id: DRAWING_DATA_TIMER_ID,
        tickInterval: 1,
        totalRuns: 0,
        callback(task) {
        	drawingCanvasProcessor();
        }
    }]);	
}

function removeOldWindows(masterDiv) {
	if (masterDiv !== null) {
		$(document).ready(function() {
			$('[id^="' + masterDiv.id + '-"]').remove();
		});
	}
}

function reset() {
	$($.id(CLIPBOARD_ID)).off('blur focus').parent().remove();
	$(window).off('mousemove mouseleave');
	clipboardActive(false)
	DRAWING_DATA_TIMER.stop();
	DRAWING_DATA_RUNNING = false;
	DRAWING_DATA_SEQUENCE = [];
	DRAWING_DATA_TIMER_RUNNING = false;
	KEYBOARD_CAPS_LOCK = null; 
	KEYBOARD_NUM_LOCK = null;
	MODIFIERS = {};
	MOUSE_WHEEL_DELTA_X = {};
	MOUSE_WHEEL_DELTA_Y = {};
	MOUSE_WHEEL_PRECISE = {};
	WINDOW_FOCUSED = '';
	WINDOW_TITLE_BAR_BUTTON_IMAGE = {};
	WINDOW_TITLE_BAR_ICON_IMAGE = {};
}

function resizeMaximizedWindows($server, $element) {
	var $mainDiv = null;
	var windowsFocus = '';
	$element.find('div[id^="' + $element.first().attr('id') + '-"]').not('div[id$="-canvas"]').each(function() {
		var maximized = $(this).parent().find('button[class~="maximize"]').hasClass('disable') || false;
		var mainId = this.id.split('-');
		var id = mainId.pop();
		windowsFocus += maximized ? '+' : '-';
		windowsFocus += id + ';';
		$mainDiv = $mainDiv === null ? $($.id(mainId.join('-'))) : $mainDiv;
	});

	// update windows focus
	if (windowsFocus !== '' && $mainDiv !== null && $mainDiv.length > 0) {
		updateWindowsFocus($mainDiv[0], windowsFocus)
	}
}

function resizeWindow(masterDiv, id, x, y, width, height, windowMaximized) {
	moveResizeWindow(masterDiv, id, x, y, width, height, windowMaximized);
}

function screenshot(masterDiv) {
	if (masterDiv !== null) {
		var marginLength = 20;
		var paperSizeFactor = 72/96; // don't change
		var $mainDiv = $($.id(masterDiv.id));
		var pdf = new jsPDF('landscape', 'px', [($mainDiv.width() + 2 * marginLength) * paperSizeFactor, ($mainDiv.height() + 3 * marginLength) * paperSizeFactor], false, true);

		// background, logo
		OFFSCREEN_CANVAS = document.createElement(DRAWING_DATA_CANVAS);
		OFFSCREEN_CANVAS.width = $mainDiv.width() + 2 * marginLength;
		OFFSCREEN_CANVAS.height = $mainDiv.height() + 3 * marginLength;
		OFFSCREEN_CANVAS_CONTEXT = OFFSCREEN_CANVAS.getContext('2d');
		OFFSCREEN_CANVAS_CONTEXT.fillStyle = '#ffffff';
		OFFSCREEN_CANVAS_CONTEXT.fillRect(0, 0, $mainDiv.width() + 2 * marginLength, $mainDiv.height() + 3 * marginLength);
		OFFSCREEN_CANVAS_CONTEXT.drawImage(WINDOW_LOGO_IMAGE, marginLength + ($mainDiv.width() - 145) / 2, marginLength + ($mainDiv.height() - 34) / 2);

		// windows
		$mainDiv.find('canvas[id^="' + masterDiv.id + '-"][id$="-canvas"]').not('div[class*="overlay"]').each(function() {
			var $this = $(this);
			var position =  $this.parent().parent().position();
			var $titleBar = $this.parent().parent().children('div.ui-dialog-titlebar');
			var $titleBarIcon = $titleBar.find('img');
			var $titleBarText = $titleBar.find('span.ui-dialog-title');
			var $titleBarButtons = $titleBar.find('button.ui-button');
			var titleBarLineWidth = getInteger($titleBar.css('borderLeftWidth'));
			var titleBarFillStyle = $titleBar.css('backgroundColor');
			var titleBarStrokeStyle = $titleBar.css('borderLeftColor');
			var titleBarWidth = $titleBar.outerWidth();
			var titleBarHeight = $titleBar.outerHeight();
			var titleBarTextFillStyle =  $titleBarText.css('color');
			var titleBarTextFontFamily = $titleBarText.css('fontFamily');
			var titleBarTextFontSize = getInteger($titleBarText.css('fontSize'));
			var titleBarTextFontWeight = $titleBarText.css('fontWeight');
			var titleBarVisible = $titleBar.css('display') !== 'none';

			var x = marginLength + position.left; // don't change
			var y = marginLength + position.top; // don't change
			var radius = titleBarVisible ? 3 : 0; // don't change
			var padding = getInteger($this.parent().parent().css('paddingLeft'));
			var lineWidth = getInteger($this.parent().parent().css('borderLeftWidth'));
			var fillStyle = $this.parent().parent().css('backgroundColor');
			var strokeStyle = $this.parent().parent().css('borderLeftColor');
			var width = $this.width() + 2 * (lineWidth + padding);
			var height = $this.height() + 2 * (lineWidth + padding) + (titleBarVisible ? titleBarHeight : 0);
			var imageData = this.getContext('2d').getImageData(0, 0, $this.width(), $this.height());

			// background, border, title bar
			if (titleBarVisible) {
				// background, border
				drawCanvasRoundedRectangle(OFFSCREEN_CANVAS_CONTEXT, x, y, width, height, radius, lineWidth, fillStyle, strokeStyle)
				x += lineWidth + padding;
				y += lineWidth + padding;
			
				// title bar
				drawCanvasRoundedRectangle(OFFSCREEN_CANVAS_CONTEXT, x, y, titleBarWidth, titleBarHeight, radius, titleBarLineWidth, titleBarFillStyle, titleBarStrokeStyle)
	
				// title bar text
				OFFSCREEN_CANVAS_CONTEXT.textAlign = 'left';
				OFFSCREEN_CANVAS_CONTEXT.textBaseline = 'middle';
				OFFSCREEN_CANVAS_CONTEXT.fillStyle = titleBarTextFillStyle
				OFFSCREEN_CANVAS_CONTEXT.font = titleBarTextFontWeight + ' ' + titleBarTextFontSize + 'px ' + titleBarTextFontFamily;
				OFFSCREEN_CANVAS_CONTEXT.fillText($titleBarText.text(), x + getInteger($titleBar.css('paddingLeft')), y + titleBarHeight/2); 
				
				// title bar icon
				if (WINDOW_TITLE_BAR_ICON_IMAGE[this.id] !== null && WINDOW_TITLE_BAR_ICON_IMAGE[this.id] !== undefined) {
					OFFSCREEN_CANVAS_CONTEXT.drawImage(WINDOW_TITLE_BAR_ICON_IMAGE[this.id], x + $titleBarIcon.parent().position().left, y + (titleBarHeight - $titleBarIcon.height())/2,
							$titleBarIcon.width(), $titleBarIcon.height());
				}
	
				// title bar buttons
				var buttonImage =  WINDOW_TITLE_BAR_BUTTON_IMAGE[this.id];
				$titleBarButtons.each(function(index) {
					var $those = $(this);
					var $icon = $those.find('span.ui-icon');
					var iconFillStyle = $icon.parent().css('backgroundColor');
					var iconLineWidth = getInteger($icon.parent().css('borderLeftWidth'));
					var iconStrokeStyle = $icon.parent().css('borderLeftColor');
					var imagePositionX = Math.abs(getInteger($icon.css('backgroundPositionX')));
					var imagePositionY = Math.abs(getInteger($icon.css('backgroundPositionY')));
					OFFSCREEN_CANVAS_CONTEXT.globalAlpha = $icon.parent().css('opacity');
					drawCanvasRoundedRectangle(OFFSCREEN_CANVAS_CONTEXT, x + $those.position().left, y + (titleBarHeight - $those.outerHeight())/2,
							$those.outerWidth(), $those.outerHeight(), radius, iconLineWidth, iconFillStyle, iconStrokeStyle)
					OFFSCREEN_CANVAS_CONTEXT.globalAlpha = 1.0;
					if (buttonImage !== undefined && buttonImage[index] !== null && buttonImage[index] !== undefined) {
						OFFSCREEN_CANVAS_CONTEXT.drawImage(buttonImage[index], imagePositionX, imagePositionY, $icon.width(), $icon.height(),
								x + $icon.parent().position().left + ($icon.parent().outerWidth() - $icon.width())/2,
								y + (titleBarHeight - $icon.height())/2, $icon.width(), $icon.height());
					}
				});
			}

			// context
			OFFSCREEN_CANVAS_CONTEXT.putImageData(imageData, x, y + (titleBarVisible ? titleBarHeight : 0));

			// canvas that we will be use to cut off image data which is in
			// outside area of canvas context
			var maskCanvas = document.createElement(DRAWING_DATA_CANVAS);
			maskCanvas.width = OFFSCREEN_CANVAS.width;
			maskCanvas.height = OFFSCREEN_CANVAS.height;
			var maskCanvasContext = maskCanvas.getContext('2d');
			maskCanvasContext.fillStyle = '#ffffff';
			maskCanvasContext.fillRect(0, 0, maskCanvas.width, maskCanvas.height);
			maskCanvasContext.globalCompositeOperation = 'xor';
			drawCanvasRoundedRectangle(maskCanvasContext, marginLength, marginLength, $mainDiv.width(), $mainDiv.height(), radius, 1, '#000', '#000');
			OFFSCREEN_CANVAS_CONTEXT.drawImage(maskCanvas, 0, 0);

			// border, screenshot info, copyright
			drawCanvasRoundedRectangle(OFFSCREEN_CANVAS_CONTEXT, marginLength, marginLength, $mainDiv.width(), $mainDiv.height(), radius, 1, 'transparent', '#000');
			OFFSCREEN_CANVAS_CONTEXT.drawImage(WINDOW_SCREENSHOT_IMAGE, marginLength, OFFSCREEN_CANVAS.height - 2 * marginLength + 3, 16, 16); 
			OFFSCREEN_CANVAS_CONTEXT.textAlign = 'left';
			OFFSCREEN_CANVAS_CONTEXT.textBaseline = 'bottom';
			OFFSCREEN_CANVAS_CONTEXT.fillStyle = '#000'
			OFFSCREEN_CANVAS_CONTEXT.font = '500 13px Arial';
			OFFSCREEN_CANVAS_CONTEXT.fillText(new Date(), 2 * marginLength, OFFSCREEN_CANVAS.height - marginLength); 
			OFFSCREEN_CANVAS_CONTEXT.textAlign = 'right';
			OFFSCREEN_CANVAS_CONTEXT.fillText(WINDOW_SCREENSHOT_CREATOR, OFFSCREEN_CANVAS.width - marginLength, OFFSCREEN_CANVAS.height - marginLength); 
		});
		
		// add canvas to pdf document
		pdf.addImage(OFFSCREEN_CANVAS.toDataURL('image/jpeg', 1.0), 'JPG', 0, 0);

		// save pdf document
		pdf.setDocumentProperties({
			title: WINDOW_SCREENSHOT_TITLE,
			creator: WINDOW_SCREENSHOT_CREATOR
	    });
		pdf.save('dvirtual.pdf');
	}
}

function showMenuBarItems() {
	if (FULL_SCREEN) {
		setTimeout(function() {
			var $fullScreenTopBars = $($.clazz(FULL_SCREEN_TOP_CLASS));
			if ($fullScreenTopBars.length > 0) {
				$fullScreenTopBars.append($('vaadin-context-menu-overlay'));
			}
		}, MENU_BAR_ITEMS_SHOW_DELAY);
	}
}

function showNotifications(show) {
	if (FULL_SCREEN && show) {
		setTimeout(function() {
			var $fullScreenTopBars = $($.clazz(FULL_SCREEN_TOP_CLASS));
			if ($fullScreenTopBars.length > 0) {
				$($.clazz('powered-by-dvirtual')).after($('vaadin-notification-container'));
			}
		}, NOTIFICATIONS_SHOW_DELAY);
	} else if (FULL_SCREEN && !show) {
		setTimeout(function() {
			$('body').append($('vaadin-notification-container'));		
		}, NOTIFICATIONS_HIDE_DELAY);
	}
}

function showTooltip() {
	if (FULL_SCREEN) {
		setTimeout(function() {
			var $fullScreenTopBars = $($.clazz(FULL_SCREEN_TOP_CLASS));
			if ($fullScreenTopBars.length > 0) {
				$($.clazz('powered-by-dvirtual')).after($('[id^="tippy-"]'));
			}
		}, TOOLTIP_SHOW_DELAY);
	}
}

function translations(applications, runningApplications) {
	TRANSLATION_APPLICATIONS = applications;
	TRANSLATION_RUNNING_APPLICATIONS = runningApplications;
}

function updateWindowsFocus(masterDiv, windowsFocus) {
	$(document).ready(function() {
		if (masterDiv !== null && windowsFocus !== null && !windowsFocus.isEmpty()) {
			var $mainDiv = $($.id(masterDiv.id));
			var $server = getServer($mainDiv.parent());
			var focusId = 0;
			$.each(windowsFocus.split(';'), function(index, windowId) {
				if (!windowId.isEmpty() && $server !== undefined) {
					var id = getInteger(windowId);
					// id > 0: window is maximized
					if (id > 0) {
						var dxy = calculateDxy(masterDiv.id + '-' + id);
						var width = $mainDiv.innerWidth() - 2 * dxy[0];
						var height = $mainDiv.innerHeight() - 2 * dxy[1] - dxy[2];
						var functionExecuted1 = false;
						setTimeout(function run() {
							if (!isAnotherRequestActive()) {
								try {
									$server.setWindowMaximized(id, width, height, true);
									moveResizeWindow($mainDiv[0], id, 0, 0, width, height, true);
									functionExecuted1 = true;
								} catch (error) {
									functionExecuted1 = false;
								}
							}
							// function is not executed, let's try again
							if (functionExecuted1 === false) {
								setTimeout(run, REQUEST_ANOTHER_INTERVAL);
							}
						}, REQUEST_FIRST_INTERVAL);				
					} else {
						var $canvasDiv = $($.id(masterDiv.id + '-' + Math.abs(id)));
						if($canvasDiv.length > 0) {
							var position = $canvasDiv.parent().position();
							var left = Math.round(position.left);
							var top = Math.round(position.top);
							var height = Math.round($canvasDiv.children().first().innerHeight());
							var width = Math.round($canvasDiv.children().first().innerWidth());
							var functionExecuted2 = false;
							setTimeout(function run() {
								if (!isAnotherRequestActive()) {
									try {
										$server.setWindowDimensions(Math.abs(id), left, top, width, height);
										functionExecuted2 = true;
									} catch (error) {
										functionExecuted2 = false;
									}
								}
								// function is not executed, let's try again
								if (functionExecuted2 === false) {
									setTimeout(run, REQUEST_ANOTHER_INTERVAL);
								}
							}, REQUEST_FIRST_INTERVAL);
						}
					}
					focusId = Math.abs(id);
					newWindowFocus(masterDiv, focusId);
				}
			});
			if ($server !== undefined && focusId > 0) {
				var functionExecuted3 = false;
				setTimeout(function run() {
					if (!isAnotherRequestActive()) {
						try {
							$server.setWindowFocus(focusId);
							functionExecuted3 = true;
						} catch (error) {
							functionExecuted3 = false;
						}
					}
					// function is not executed, let's try again
					if (functionExecuted3 === false) {
						setTimeout(run, REQUEST_ANOTHER_INTERVAL);
					}
				}, REQUEST_FIRST_INTERVAL);
			}
		}
		$('[role="log"]').remove();
	});
}

function windowAction(masterDiv, id, action) {
	$(document).ready(function() {
		if (masterDiv !== null) {
			var canvasDivId = masterDiv.id + '-' + id;
			var $canvasDiv = $($.id(canvasDivId)).parent()
			var $button = undefined;
			switch (action) {
				case WINDOW_ACTION.CLOSE_WINDOW:
					$button = $canvasDiv.find('span[class~="ui-icon-closethick"]').parent();
					break;
				case WINDOW_ACTION.MAXIMIZE_WINDOW:
					$button = $canvasDiv.find('span[class~="ui-icon-extlink"]').parent();
					break;
				case WINDOW_ACTION.RESTORE_WINDOW:
					$button = $canvasDiv.find('span[class~="ui-icon-newwin"]').parent();
					break;
				default:
					break;
			}
			$('div[role="log"]').remove();
			
			// trigger button click
			if ($button !== undefined && $button.length && !$button.attr('class').includes('disable')) {
				$button.click();
			}

			// trigger title click
			if (action !== WINDOW_ACTION.CLOSE_WINDOW) {
				setTimeout(function() {
					WINDOW_FOCUSED = '';
					$canvasDiv.find('span[class~="ui-icon-closethick"]').parent().parent().trigger('mousedown');
				}, WINDOW_TITLE_CLICK_DELAY);
			}
		}
	});
}
